/*
 *
 * Copyright (c) 2013-2021, Alibaba Group Holding Limited;
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: TxnStream.proto

package com.aliyun.polardbx.binlog.protocol;

/**
 * Protobuf enum {@code com.aliyun.polardbx.binlog.protocol.MessageType}
 */
public enum MessageType
    implements com.google.protobuf.ProtocolMessageEnum {
    /**
     * <pre>
     * *
     * Begin,Data,End未拆分，一个完整的消息体
     * </pre>
     *
     * <code>WHOLE = 0;</code>
     */
    WHOLE(0),
    /**
     * <pre>
     * *
     * Message开始标识
     * </pre>
     *
     * <code>BEGIN = 1;</code>
     */
    BEGIN(1),
    /**
     * <pre>
     * *
     * Message包含的数据
     * </pre>
     *
     * <code>DATA = 2;</code>
     */
    DATA(2),
    /**
     * <pre>
     * *
     * Message结束标识
     * </pre>
     *
     * <code>END = 3;</code>
     */
    END(3),
    /**
     * <pre>
     * *
     * 一个独立的消息标记，当没有TxnItem需要传递时，使用该类型
     * </pre>
     *
     * <code>TAG = 4;</code>
     */
    TAG(4),
    UNRECOGNIZED(-1),
    ;

    /**
     * <pre>
     * *
     * Begin,Data,End未拆分，一个完整的消息体
     * </pre>
     *
     * <code>WHOLE = 0;</code>
     */
    public static final int WHOLE_VALUE = 0;
    /**
     * <pre>
     * *
     * Message开始标识
     * </pre>
     *
     * <code>BEGIN = 1;</code>
     */
    public static final int BEGIN_VALUE = 1;
    /**
     * <pre>
     * *
     * Message包含的数据
     * </pre>
     *
     * <code>DATA = 2;</code>
     */
    public static final int DATA_VALUE = 2;
    /**
     * <pre>
     * *
     * Message结束标识
     * </pre>
     *
     * <code>END = 3;</code>
     */
    public static final int END_VALUE = 3;
    /**
     * <pre>
     * *
     * 一个独立的消息标记，当没有TxnItem需要传递时，使用该类型
     * </pre>
     *
     * <code>TAG = 4;</code>
     */
    public static final int TAG_VALUE = 4;

    public final int getNumber() {
        if (this == UNRECOGNIZED) {
            throw new java.lang.IllegalArgumentException(
                "Can't get the number of an unknown enum value.");
        }
        return value;
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static MessageType valueOf(int value) {
        return forNumber(value);
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     */
    public static MessageType forNumber(int value) {
        switch (value) {
        case 0:
            return WHOLE;
        case 1:
            return BEGIN;
        case 2:
            return DATA;
        case 3:
            return END;
        case 4:
            return TAG;
        default:
            return null;
        }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<MessageType>
    internalGetValueMap() {
        return internalValueMap;
    }

    private static final com.google.protobuf.Internal.EnumLiteMap<
        MessageType> internalValueMap =
        new com.google.protobuf.Internal.EnumLiteMap<MessageType>() {
            public MessageType findValueByNumber(int number) {
                return MessageType.forNumber(number);
            }
        };

    public final com.google.protobuf.Descriptors.EnumValueDescriptor
    getValueDescriptor() {
        if (this == UNRECOGNIZED) {
            throw new java.lang.IllegalStateException(
                "Can't get the descriptor of an unrecognized enum value.");
        }
        return getDescriptor().getValues().get(ordinal());
    }

    public final com.google.protobuf.Descriptors.EnumDescriptor
    getDescriptorForType() {
        return getDescriptor();
    }

    public static final com.google.protobuf.Descriptors.EnumDescriptor
    getDescriptor() {
        return com.aliyun.polardbx.binlog.protocol.TxnStream.getDescriptor().getEnumTypes().get(0);
    }

    private static final MessageType[] VALUES = values();

    public static MessageType valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
            throw new java.lang.IllegalArgumentException(
                "EnumValueDescriptor is not for this type.");
        }
        if (desc.getIndex() == -1) {
            return UNRECOGNIZED;
        }
        return VALUES[desc.getIndex()];
    }

    private final int value;

    private MessageType(int value) {
        this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:com.aliyun.polardbx.binlog.protocol.MessageType)
}

